unit U_ClothPurchasePlanPut;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridLevel, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxClasses, cxControls, cxGridCustomView, cxGrid, cxMemo,
  cxRichEdit, ComCtrls, cxContainer, cxTextEdit, cxMaskEdit, cxButtonEdit,
  StdCtrls, ToolWin, DBClient, ADODB, ExtCtrls, BtnEdit, cxCalendar, StrUtils,
  cxDropDownEdit, cxGridCustomPopupMenu, cxGridPopupMenu, cxLookAndFeels,
  cxLookAndFeelPainters, cxNavigator, dxDateRanges, dxBarBuiltInMenu,
  dxDateTimeWheelPicker, dxGDIPlusClasses, Vcl.Menus, MovePanel, cxCheckBox,
  cxImage, cxDBEdit, Vcl.DBCtrls, U_BaseInput, System.ImageList, Vcl.ImgList,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdExplicitTLSClientServerBase, IdFTP, ShellAPI, dxScrollbarAnnotations, dxCore,
  cxDateUtils, cxImageList, dxSkinsCore, dxSkinsDefaultPainters;

type
  TfrmClothPurchasePlanPut = class(TfrmBaseInput)
    ToolBar1: TToolBar;
    TBSave: TToolButton;
    TBClose: TToolButton;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ADOTemp: TADOQuery;
    ADOCmd: TADOQuery;
    DS_1: TDataSource;
    Order_Sub: TClientDataSet;
    cxgrdpmn1: TcxGridPopupMenu;
    pm_sub: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    ToolButton3: TToolButton;
    ScrollBox1: TScrollBox;
    cxGrid1: TcxGrid;
    TV1: TcxGridDBTableView;
    cxGridDBColumn13: TcxGridDBColumn;
    cxGridDBColumn14: TcxGridDBColumn;
    cxGridDBColumn15: TcxGridDBColumn;
    cxGridDBColumn16: TcxGridDBColumn;
    cxGridDBColumn17: TcxGridDBColumn;
    cxGridDBColumn18: TcxGridDBColumn;
    cxGridDBColumn19: TcxGridDBColumn;
    cxGridDBColumn20: TcxGridDBColumn;
    cxGridDBColumn21: TcxGridDBColumn;
    cxGridDBColumn22: TcxGridDBColumn;
    cxGridDBColumn23: TcxGridDBColumn;
    cxGridDBColumn24: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    lbl5: TLabel;
    lbl6: TLabel;
    lbl7: TLabel;
    lbl8: TLabel;
    lbl9: TLabel;
    lbl10: TLabel;
    lbl1: TLabel;
    lbl2: TLabel;
    lbl3: TLabel;
    lbl4: TLabel;
    PurNo: TcxTextEdit;
    ShippMent: TcxTextEdit;
    Sellname: TcxButtonEdit;
    BuyName: TcxButtonEdit;
    PurDate: TcxDateEdit;
    Payment: TcxButtonEdit;
    QtyNote: TcxButtonEdit;
    ShipMent: TcxButtonEdit;
    IsTax: TcxComboBox;
    DlyDate: TcxDateEdit;
    cxGrid2: TcxGrid;
    TV2: TcxGridDBTableView;
    cxGridLevel2: TcxGridLevel;
    TV2Column1: TcxGridDBColumn;
    TV2Column2: TcxGridDBColumn;
    TV2Column3: TcxGridDBColumn;
    DS_2: TDataSource;
    CDS_2: TClientDataSet;
    GPM_2: TcxGridPopupMenu;
    ADO_2: TADOQuery;
    TV1Column1: TcxGridDBColumn;
    ToolButton4: TToolButton;
    Label35: TLabel;
    ConNo: TcxButtonEdit;
    TV1Column2: TcxGridDBColumn;
    TV1Column3: TcxGridDBColumn;
    TV1Column4: TcxGridDBColumn;
    TV1Column5: TcxGridDBColumn;
    TV1Column6: TcxGridDBColumn;
    TV1Column7: TcxGridDBColumn;
    TV1Column8: TcxGridDBColumn;
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure BuyNameBtnUpClick(Sender: TObject);
    procedure v1Column4PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column6PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column7PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column10PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure SalesmanBtnUpClick(Sender: TObject);
    procedure v1Column15PropertiesEditValueChanged(Sender: TObject);
    procedure SellNameBtnUpClick(Sender: TObject);
    procedure v1PRTOrderQtyPropertiesEditValueChanged(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure ShippMentKeyPress(Sender: TObject; var Key: Char);
    procedure ToolButton3Click(Sender: TObject);
    procedure BuyNameDblClick(Sender: TObject);
    procedure BuyNamePropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure SellnamePropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure ShipMentPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure TV1FocusedRecordChanged(Sender: TcxCustomGridTableView; APrevFocusedRecord, AFocusedRecord: TcxCustomGridRecord; ANewItemRecordFocusingChanged: Boolean);
    procedure ToolButton4Click(Sender: TObject);
    procedure ConNoPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
  private
    FLeft, FTop: Integer;
    fuserName, Fstatus: string;
    procedure JSMoney();
    procedure InitData();
    procedure ZDYHelp(FButn: TcxButtonEdit; LType: string);
    function TestData(): Boolean;
    function SaveData(): Boolean;
    procedure SetXH();
    { Private declarations }
  public
    CopyInt: Integer;
    PState: string;
    fFlileFlag: string;
    FPurMId: string;
    FAuthority, FGSTT: string;
    { Public declarations }
  end;

var
  frmClothPurchasePlanPut: TfrmClothPurchasePlanPut;
  newh: hwnd;

implementation

uses
  U_DataLink, U_RTFun, U_ZDYHelp, U_CompanySel, U_ClothInfoSel,
  U_TatClothInfoSel, U_TradeSalesContractSel;

{$R *.dfm}

procedure TfrmClothPurchasePlanPut.SetXH();
var
  i: Integer;
begin
  with Order_Sub do
  begin
    First;
    i := 1;
    while not Eof do
    begin
      with Order_Sub do
      begin
        Edit;
        FieldByName('XHNoTemp').Value := i;
        Post;
      end;
      i := i + 1;
      Next;
    end;
  end;

  with Order_Sub do
  begin
    Order_Sub.IndexFieldNames := '';
    First;
    i := 1;
    while not Eof do
    begin
      with Order_Sub do
      begin
        Edit;
        FieldByName('SerialNo').Value := FieldByName('XHNoTemp').AsInteger;
        Post;
      end;
      i := i + 1;
      Next;
    end;
    Order_Sub.IndexFieldNames := 'SerialNo';
  end;
end;

procedure TfrmClothPurchasePlanPut.ShipMentPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
var
  fsj: string;
  FWZ: Integer;
begin
  fsj := Trim(TcxButtonEdit(Sender).Hint);
  FWZ := Pos('/', fsj);
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      MainType := 'Pur';
      flag := Copy(fsj, 1, FWZ - 1);
      flagname := Copy(fsj, FWZ + 1, Length(fsj) - FWZ);
      if ShowModal = 1 then
      begin
        TcxButtonEdit(Sender).Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothPurchasePlanPut.ShippMentKeyPress(Sender: TObject; var Key: Char);
begin

  if not (((Key >= '0') and (Key <= '9')) or (Key = '.') or (Key = #8)) then
  begin
    Key := #0;
  end
  else if (pos('.', TEdit(Sender).text) <> 0) then
  begin
    if Key = '.' then
    begin
      Key := #0;
    end;
  end;
end;

procedure TfrmClothPurchasePlanPut.JSMoney();
var
  FConQty, FConPrice, FC_Money: Double;
begin
  with Order_Sub do
  begin
    FConQty := Fieldbyname('ConQty').AsFloat;
    FConPrice := Fieldbyname('ConPrice').AsFloat;
  end;
  //计算金额，保留2位小数
  FC_Money := RoundFloat(FConQty * FConPrice, 2);
  with Order_Sub do
  begin
    Edit;
    FieldByName('ConTotalAmount').Value := FC_Money;
    Post;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

function TfrmClothPurchasePlanPut.TestData(): Boolean;
begin
  try
    if Trim(PurNo.Text) = '' then
      raise Exception.Create('采购单号号不能为空！');
    if Trim(SellName.Text) = '' then
      raise Exception.Create('供应商不能为空！');
    if Trim(BuyName.Text) = '' then
      raise Exception.Create('我方单位不能为空！');

    if Order_Sub.IsEmpty then
      raise Exception.Create('明细不能为空！');
    if Order_Sub.Locate('C_Name', null, []) then
      raise Exception.Create('品名不能为空！');
    if Order_Sub.Locate('C_Name', '', []) then
      raise Exception.Create('品名不能为空！');
    if Order_Sub.Locate('Price', null, []) then
      raise Exception.Create('单价不能为空！');
    if Order_Sub.Locate('Qty', null, []) then
      raise Exception.Create('数量不能为空！');
    if Order_Sub.Locate('Qty', 0, []) then
      raise Exception.Create('数量不能为0！');
    if Order_Sub.Locate('QtyUnit', null, []) then
      raise Exception.Create('数量单位不能为空！');
    if Order_Sub.Locate('QtyUnit', '', []) then
      raise Exception.Create('数量单位不能为空！');
    Result := True;
  except
    Result := false;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;
end;

procedure TfrmClothPurchasePlanPut.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmClothPurchasePlanPut.InitData();
var
  maxno: string;
begin
  //刷新产品信息
  with ADOTemp do
  begin
    Close;
    SQL.Clear;
    sql.Add(' select * from Pur_ClothPlan_Sub ');
    sql.Add('where PurMId=''' + Trim(FPurMId) + '''');
    sql.Add(' order by SerialNo ');
    Open;
  end;
  SCreateCDS(ADOTemp, Order_Sub);
  SInitCDSData(ADOTemp, Order_Sub);
   //刷新条款信息
  with ADOTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from Pur_ClothPlan_Main where PurMId=''' + Trim(FPurMId) + '''');
    Open;
  end;
  SCSHData(ADOTemp, ScrollBox1, 2);
  BuyName.Properties.LookupItems.Text := Trim(ADOTemp.FieldByName('BuyNo').AsString);
  Sellname.Properties.LookupItems.Text := Trim(ADOTemp.FieldByName('SellNo').AsString);
  Fstatus := Trim(ADOTemp.FieldByName('status').AsString);

  if PState = '新增' then
  begin
    PurDate.Date := SGetServerDateTime(ADOTemp);
    DlyDate.Date := PurDate.Date;
    PurNo.Text := '自动生成';
  end;

  if PState = '复制' then
  begin
    PState := '新增';
    FPurMId := '';
    PurNo.Text := '自动生成';

    with Order_Sub do
    begin
      First;
      while not Eof do
      begin
        if GetLSNo(ADOCmd, maxno, 'SCS', 'Pur_ClothPlan_Sub', 4, 1) = False then
        begin
          Application.MessageBox('取子流水号失败！', '提示', 0);
          Exit;
        end;
        Edit;
        FieldByName('PurMId').Value := '';
        FieldByName('PurSId').Value := maxno;
        Post;
        Next;
      end;
    end;
  end;

end;

procedure TfrmClothPurchasePlanPut.N1Click(Sender: TObject);
var
  FValue, FFValue, FColumn, FFColumn, MHXSID: string;
  MXHNO: Integer;
begin
  if Fstatus = '1' then
  begin
    application.MessageBox('合同已审核，无法操作！', '提示信息', 0);
    exit;
  end;
  MXHNO := Order_Sub.FieldByName('XHNo').ASInteger;
  FColumn := Tv1.Controller.FocusedColumn.DataBinding.FilterFieldName;
  FValue := Trim(Order_Sub.fieldbyname(FColumn).AsString);
  MHXSID := Trim(Order_Sub.fieldbyname('HXSID').AsString);
  with Order_Sub do
  begin
    DisableControls;
    First;
    while not Eof do
    begin
      if FieldByName('SSel').AsBoolean then
      begin
        Edit;

        if FValue = '' then
        begin
          Order_Sub.FieldByName(FColumn).Value := null;
        end
        else
        begin
          Order_Sub.FieldByName(FColumn).Value := FValue;
        end;
        if FColumn = 'C_HX' then
        begin
          Order_Sub.FieldByName('HXSID').Value := MHXSID;
        end;
        Post;
        JSMoney();
      end;
      Next;
    end;
    EnableControls;
  end;
  Order_Sub.Locate('XHNO', MXHNO, []);
end;

procedure TfrmClothPurchasePlanPut.N2Click(Sender: TObject);
var
  FValue, MC_Code, MC_Craft, MC_Name, MC_Spec, MC_CF, MC_Color, MC_MF, MC_KZ, MC_Note, MC_Unit, MGcHuaNo, MSuoLv, MC_EName: string;
  MXHNO: Integer;
begin
  if Fstatus = '1' then
  begin
    application.MessageBox('合同已审核，无法操作！', '提示信息', 0);
    exit;
  end;

  MXHNO := Order_Sub.FieldByName('XHNo').ASInteger;
  MC_Code := Order_Sub.fieldbyname('C_Code').AsString;
  MC_Craft := Order_Sub.fieldbyname('C_Craft').AsString;
  MC_Name := Order_Sub.fieldbyname('C_Name').AsString;
  MC_Spec := Order_Sub.fieldbyname('C_Spec').AsString;
  MC_CF := Order_Sub.fieldbyname('C_CF').AsString;
  MC_Color := Order_Sub.fieldbyname('C_Color').AsString;
  MC_MF := Order_Sub.fieldbyname('C_MF').AsString;
  MC_KZ := Order_Sub.fieldbyname('C_KZ').AsString;
  MC_Note := Order_Sub.fieldbyname('C_Note').AsString;
  MC_Unit := Order_Sub.fieldbyname('C_Unit').AsString;
  MSuoLv := Order_Sub.fieldbyname('SuoLv').AsString;
  MGcHuaNo := Order_Sub.fieldbyname('GcHuaNo').AsString;
  MC_EName := Order_Sub.fieldbyname('C_EName').AsString;

  with Order_Sub do
  begin
    DisableControls;
    First;
    while not Eof do
    begin
      if FieldByName('SSel').AsBoolean then
      begin
        Edit;
        Order_Sub.fieldbyname('C_Code').Value := MC_Code;
        Order_Sub.fieldbyname('C_Craft').Value := MC_Craft;
        Order_Sub.fieldbyname('C_Name').Value := MC_Name;
        Order_Sub.fieldbyname('C_Spec').Value := MC_Spec;
        Order_Sub.fieldbyname('C_CF').Value := MC_CF;
        Order_Sub.fieldbyname('C_Color').Value := MC_Color;
        Order_Sub.fieldbyname('C_MF').Value := MC_MF;
        Order_Sub.fieldbyname('C_KZ').Value := MC_KZ;
        Order_Sub.fieldbyname('C_Note').Value := MC_Note;
        Order_Sub.fieldbyname('C_Unit').Value := MC_Unit;
        Order_Sub.fieldbyname('SuoLv').Value := MSuoLv;
        Order_Sub.fieldbyname('GcHuaNo').Value := MGcHuaNo;
        Order_Sub.fieldbyname('C_EName').Value := MC_EName;
        Post;

      end;
      Next;
    end;
    EnableControls;
  end;
  Order_Sub.Locate('XHNO', MXHNO, []);
end;

procedure TfrmClothPurchasePlanPut.ZDYHelp(FButn: TcxButtonEdit; LType: string);
var
  FType, ZDYName, FText: string;
begin
end;

procedure TfrmClothPurchasePlanPut.BuyNameDblClick(Sender: TObject);
begin
  TcxButtonEdit(Sender).Text := '';
  TcxButtonEdit(Sender).Properties.LookupItems.Text := '';
end;

procedure TfrmClothPurchasePlanPut.BuyNamePropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '我司';
      if ShowModal = 1 then
      begin
        self.BuyName.Properties.LookupItems.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoCode').AsString);
        self.BuyName.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoName').AsString);
      end;
    end;

  finally
    frmCompanySel.Free;
  end;
end;

procedure TfrmClothPurchasePlanPut.ConNoPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
var
  maxno: string;
  i: Integer;
begin
  try
    frmTradeSalesContractSel := TfrmTradeSalesContractSel.Create(Application);
    with frmTradeSalesContractSel do
    begin

      if ShowModal = 1 then
      begin
        with frmTradeSalesContractSel.CDS_1 do
        begin
          First;
          while not Eof do
          begin
            if Fieldbyname('ssel').AsBoolean then
            begin

              self.ConNO.Text := Trim(frmTradeSalesContractSel.CDS_1.fieldbyname('ConNO').AsString);

              if GetLSNo(ADOCmd, maxno, 'PS', 'Pur_ClothPlan_Sub', 4, 1) = False then
              begin
                ADOCmd.Connection.RollbackTrans;
                Application.MessageBox('取子流水号失败！', '提示', 0);
                Exit;
              end;

              i := Order_Sub.RecordCount;      //当前的dataset有多少行记录
              i := i + 1;
              with Self.Order_Sub do
              begin
                Append;

                FieldByName('SerialNo').Value := i;
                FieldByName('PurSID').Value := maxno + INTTOSTR(i);
                FieldByName('C_Degree').Value := '坯布';

                FieldByName('ConNO').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('ConNO').Value;
                FieldByName('ConMID').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('ConMID').Value;
                FieldByName('ConSID').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('ConSID').Value;

                FieldByName('C_Code').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('C_Code').Value;
                FieldByName('C_Name').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('C_Name').Value;

                FieldByName('C_Spec').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('C_Spec').Value;
                FieldByName('C_Composition').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('C_Composition').Value;

                FieldByName('C_Color').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('C_Color').Value;
                FieldByName('C_ColorNo').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('C_ColorNo').Value;

                FieldByName('C_Pattern').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('C_Pattern').Value;
                FieldByName('C_StyleNo').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('C_StyleNo').Value;

                FieldByName('C_Width').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('C_Width').Value;
                FieldByName('C_GramWeight').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('C_GramWeight').Value;

                FieldByName('BBNO').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('BBNO').Value;

                FieldByName('Qty').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('ConQty').Value;
                FieldByName('QtyUnit').Value := frmTradeSalesContractSel.CDS_1.fieldbyname('ConUnit').Value;

                Post;
              end;
            end;

            Next;
            i := i + 1;
          end;
        end;

      end;
    end;
  finally
    frmTradeSalesContractSel.Free;
  end;
end;

procedure TfrmClothPurchasePlanPut.FormShow(Sender: TObject);
begin
  inherited;
  readCxGrid(trim(self.Caption) + 'Tv1', Tv1, '销售合同管理');
  readCxGrid(trim(self.Caption) + 'Tv2', Tv2, '销售合同管理');
  fFlileFlag := UserDataFlag + 'HX';
  InitData();

end;

function TfrmClothPurchasePlanPut.SaveData(): Boolean;
var
  maxno: string;
  MPurNo, fDate: string;
begin
  try
    ADOCmd.Connection.BeginTrans;
////////////////       保存主表          //////////////////////
    if Trim(FPurMId) = '' then
    begin
      if GetLSNo(ADOTemp, maxno, 'PM', 'Pur_ClothPlan_Main', 3, 1) = False then
        raise Exception.Create('取最大号失败！');

      fDate := FormatDateTime('yy', SGetServerDate(ADOTemp));

      if trim(PurNo.Text) = '自动生成' then
      begin
        if GetLSNo(ADOTemp, MPurNo, fDate, 'Pur_ClothPlan_Main', 4, 0) = False then
          raise Exception.Create('取最新采购单号失败！');
        PurNo.Text := MPurNo;
      end;
    end
    else
    begin
      maxno := Trim(FPurMId);
    end;
    with ADOCmd do
    begin
      Close;
      sql.Clear;
      SQL.Add('select * from Pur_ClothPlan_Main where PurMId=''' + Trim(FPurMId) + '''');
      Open;
    end;
    with ADOCmd do
    begin
      if Trim(FPurMId) = '' then
      begin
        Append;
        FieldByName('Filler').Value := Trim(DName);
        FieldByName('status').Value := '0';
      end
      else
      begin
        Edit;
        FieldByName('Editer').Value := Trim(DName);
        FieldByName('EditTime').Value := SGetServerDateTime(ADOTemp);
      end;
      FieldByName('PurMId').Value := Trim(maxno);
      RTSetsavedata(ADOCmd, 'Pur_ClothPlan_Main', ScrollBox1, 2);
      FieldByName('BuyNo').Value := Trim(BuyName.Properties.LookupItems.Text);
      FieldByName('SellNo').Value := Sellname.Properties.LookupItems.Text;
      Post;
    end;
    with ADOCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from Pur_ClothPlan_Main where PurNo=''' + Trim(PurNo.Text) + '''');
      Open;
    end;
    if ADOCmd.RecordCount > 1 then
      raise Exception.Create('采购单号重复！');

    FPurMId := Trim(maxno);
////////////////       保存主表          //////////////////////
///
////////////////       保存子表          //////////////////////
    with Order_Sub do
    begin
      First;
      while not Eof do
      begin

        maxno := Trim(Order_Sub.fieldbyname('PurSId').AsString);

        with ADOCmd do
        begin
          Close;
          SQL.Clear;
          sql.Add('select * from Pur_ClothPlan_Sub    ');
          sql.Add('where   PurSId=''' + Trim(maxno) + '''');
          SQL.Add('and PurMId=''' + Trim(FPurMId) + '''');
          Open;
        end;
        with ADOCmd do
        begin
          if ADOCmd.IsEmpty then
            Append
          else
            Edit;
          RTSetSaveDataCDS(ADOCmd, Tv1, Order_Sub, 'Pur_ClothPlan_Sub', 0);
          FieldByName('PurMId').Value := Trim(FPurMId);
          FieldByName('PurSId').Value := Trim(maxno);

          FieldByName('ConNO').Value := Trim(Order_Sub.fieldbyname('ConNO').AsString);
          FieldByName('ConMID').Value := Trim(Order_Sub.fieldbyname('ConMID').AsString);
          FieldByName('ConSID').Value := Trim(Order_Sub.fieldbyname('ConSID').AsString);
          Post;
        end;
        with Order_Sub do
        begin
          Edit;
          FieldByName('PurSId').Value := Trim(maxno);
          Post;
        end;
        Next;
      end;
    end;
////////////////       保存子表          //////////////////////

    ADOCmd.Connection.CommitTrans;
    Result := True;
  except

    ADOCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    Result := False;
  end;
end;

procedure TfrmClothPurchasePlanPut.TBSaveClick(Sender: TObject);
begin
  PurDate.SetFocus;

  if TestData() = false then
    exit;

  if SaveData() then
  begin
    Application.MessageBox('保存成功！', '提示', 0);
  end;
end;

procedure TfrmClothPurchasePlanPut.v1PRTOrderQtyPropertiesEditValueChanged(Sender: TObject);
var
  mvalue, FFieldName: string;
  FQty, FPrice, FAmount: Double;        //个数，单价，金额
begin
  mvalue := TcxTextEdit(Sender).EditingText;
  if Trim(mvalue) = '' then
  begin
    mvalue := '0';
  end;
  FFieldName := Trim(Tv1.Controller.FocusedColumn.DataBinding.FilterFieldName);

  with Order_Sub do
  begin
    Edit;
    FieldByName(FFieldName).Value := Trim(mvalue);
    Post;
    FQty := Fieldbyname('Qty').AsFloat;
    FPrice := Fieldbyname('Price').AsFloat;
  end;
  FAmount := RoundFloat(FQty * FPrice, 2);

  with Order_Sub do
  begin
    Edit;
    FieldByName('Qty').Value := FQty;
    FieldByName('Price').Value := FPrice;
    FieldByName('Amount').Value := FAmount;
    Post;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmClothPurchasePlanPut.ToolButton1Click(Sender: TObject);
var
  i: Integer;
  maxno: string;
begin

  if GetLSNo(ADOCmd, maxno, 'PS', 'Pur_ClothPlan_Sub', 4, 1) = False then
  begin
    ADOCmd.Connection.RollbackTrans;
    Application.MessageBox('取子流水号失败！', '提示', 0);
    Exit;
  end;
  i := Order_Sub.RecordCount + 1;

  try
    frmTatClothInfoSel := TfrmTatClothInfoSel.Create(Application);
    with frmTatClothInfoSel do
    begin
      if ShowModal = 1 then
      begin
        with CDS_1 do
        begin
          First;
          while not Eof do
          begin
            if CDS_1.fieldbyname('SSel').AsBoolean then
            begin
              with Self.Order_Sub do
              begin
                Append;
                FieldByName('SSEL').Value := False;
                FieldByName('SerialNo').Value := i;
                FieldByName('PurSId').Value := maxno + INTTOSTR(i);
                FieldByName('C_Code').Value := CDS_1.fieldbyname('C_Code').value;
                FieldByName('C_Name').Value := CDS_1.fieldbyname('C_Name').value;
                FieldByName('C_Spec').Value := CDS_1.fieldbyname('C_Spec').value;
                FieldByName('C_Composition').Value := CDS_1.fieldbyname('C_Composition').value;
                FieldByName('C_Color').Value := CDS_1.fieldbyname('C_Color').value;
                FieldByName('Qty').Value := 0;
                FieldByName('QtyUnit').Value := 'Kg';
//                FieldByName('C_Degree').Value := '成品';
              end;
            end;
            i := i + 1;
            Next;
          end;
        end;
      end;
    end;
  finally
    frmTatClothInfoSel.Free;
  end;
  SetXH();
end;

procedure TfrmClothPurchasePlanPut.ToolButton2Click(Sender: TObject);
begin
  if Order_Sub.IsEmpty then
    Exit;
  if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
    Exit;
  while Order_Sub.Locate('SSel', True, []) do
  begin
//    with ADOTemp do
//    begin
//      Close;
//      sql.Clear;
//      sql.Add('select * from  Trade_Plan_Sub where PurSId=''' + Trim(Order_Sub.fieldbyname('PurSId').AsString) + '''');
//      open;
//    end;
//    if ADOTemp.IsEmpty = false then
//    begin
//      exit;
//      application.MessageBox('该明细已经在生产！', '提示信息');
//    end;
    if Trim(Order_Sub.fieldbyname('PurSId').AsString) <> '' then
    begin
      with ADOCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('delete Pur_ClothPlan_Sub where PurSId=''' + Trim(Order_Sub.fieldbyname('PurSId').AsString) + '''');
        ExecSQL;
      end;
    end;
    Order_Sub.Delete;
  end;
  SetXH();
end;

procedure TfrmClothPurchasePlanPut.ToolButton3Click(Sender: TObject);
begin
  WriteCxGrid(trim(self.Caption) + 'Tv1', Tv1, '销售合同管理');
  WriteCxGrid(trim(self.Caption) + 'Tv2', Tv2, '销售合同管理');
end;

procedure TfrmClothPurchasePlanPut.ToolButton4Click(Sender: TObject);
var
  i: Integer;
  maxno: string;
begin

  if GetLSNo(ADOCmd, maxno, 'PS', 'Pur_ClothPlan_Sub', 4, 1) = False then
  begin
    ADOCmd.Connection.RollbackTrans;
    Application.MessageBox('取子流水号失败！', '提示', 0);
    Exit;
  end;
  i := Order_Sub.RecordCount + 1;
  with Self.Order_Sub do
  begin
    Append;
    FieldByName('SSEL').Value := False;
    FieldByName('SerialNo').Value := i;
    FieldByName('PurSId').Value := maxno + INTTOSTR(i);
    FieldByName('Qty').Value := 0;
    FieldByName('QtyUnit').Value := 'Kg';
    FieldByName('C_Degree').Value := '坯布';
  end;

  SetXH();
end;

procedure TfrmClothPurchasePlanPut.TV1FocusedRecordChanged(Sender: TcxCustomGridTableView; APrevFocusedRecord, AFocusedRecord: TcxCustomGridRecord; ANewItemRecordFocusingChanged: Boolean);
begin
  with ADO_2 do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.PurDate,B.C_Name,B.Price');
    sql.Add(' from Pur_ClothPlan_Main A inner join Pur_ClothPlan_Sub B on A.PurMId=B.PurMId  ');
    sql.Add('where C_Name=' + quotedstr(Trim(Order_Sub.fieldbyname('C_Name').AsString)));
    Open;
  end;
  SCreateCDS(ADO_2, CDS_2);
  SInitCDSData(ADO_2, CDS_2);
end;

procedure TfrmClothPurchasePlanPut.BuyNameBtnUpClick(Sender: TObject);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '我司';

      if ShowModal = 1 then
      begin
        self.BuyName.Properties.LookupItems.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoCode').AsString);
        self.BuyName.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoAbbrName').AsString);
      end;
    end;

  finally
    frmCompanySel.Free;
  end;

end;

procedure TfrmClothPurchasePlanPut.v1Column4PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'MPRTCodeName';
      flagname := '产品名称';
      if ShowModal = 1 then
      begin
        Order_Sub.Edit;
        Order_Sub.fieldbyname('PRTCodeName').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        Order_Sub.fieldbyname('PRTCode').Value := Trim(ClientDataSet1.fieldbyname('ZDYNo').AsString);
        Order_Sub.Post;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmClothPurchasePlanPut.v1Column6PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'C_MF';
      flagname := '门幅信息';
      if ShowModal = 1 then
      begin
        Order_Sub.Edit;
        Order_Sub.fieldbyname('C_MF').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
     //   Order_Sub.fieldbyname('PRTCode').Value:=Trim(ClientDataSet1.fieldbyname('ZDYNo').AsString);
        Order_Sub.Post;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmClothPurchasePlanPut.v1Column7PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'C_KZ';
      flagname := '克重信息';
      if ShowModal = 1 then
      begin
        Order_Sub.Edit;
        Order_Sub.fieldbyname('C_KZ').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
     //   Order_Sub.fieldbyname('PRTCode').Value:=Trim(ClientDataSet1.fieldbyname('ZDYNo').AsString);
        Order_Sub.Post;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmClothPurchasePlanPut.v1Column10PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
var
  MCYNo: string;
begin
  frmTatClothInfoSel := TfrmTatClothInfoSel.Create(self);
  with frmTatClothInfoSel do
  begin
    if showmodal = 1 then
    begin
      Order_Sub.Edit;
      Order_Sub.fieldbyname('C_Code').Value := frmTatClothInfoSel.CDS_1.fieldbyname('C_Code').asstring;
      Order_Sub.fieldbyname('C_Name').Value := frmTatClothInfoSel.CDS_1.fieldbyname('C_Name').asstring;

      Order_Sub.fieldbyname('C_Spec').Value := frmTatClothInfoSel.CDS_1.fieldbyname('C_Spec').asstring;
      Order_Sub.fieldbyname('C_Composition').Value := frmTatClothInfoSel.CDS_1.fieldbyname('C_Composition').asstring;

      Order_Sub.fieldbyname('C_Color').Value := frmTatClothInfoSel.CDS_1.fieldbyname('C_Color').asstring;

      Order_Sub.Post;
    end;
    free;
  end;

  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmClothPurchasePlanPut.SalesmanBtnUpClick(Sender: TObject);
var
  fsj: string;
  FWZ: Integer;
begin
  fsj := Trim(TEdit(Sender).Hint);
  FWZ := Pos('/', fsj);
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := Copy(fsj, 1, FWZ - 1);
      flagname := Copy(fsj, FWZ + 1, Length(fsj) - FWZ);
      if ShowModal = 1 then
      begin
        TEdit(Sender).Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;

end;

procedure TfrmClothPurchasePlanPut.v1Column15PropertiesEditValueChanged(Sender: TObject);
var
  mvalue: string;
begin
  mvalue := TcxTextEdit(Sender).EditingText;

  if Trim(mvalue) = '' then
  begin
    mvalue := '0';
  end;
  with Order_Sub do
  begin
    Edit;
    FieldByName('YongJinPrice').Value := mvalue;
    FieldByName('YongJin').Value := FieldByName('YongJinPrice').AsFloat * FieldByName('PRTOrderQty').AsFloat;
    Post;
  end;
end;

procedure TfrmClothPurchasePlanPut.SellNameBtnUpClick(Sender: TObject);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '供应商';
      if ShowModal = 1 then
      begin
        self.Sellname.Properties.LookupItems.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoCode').AsString);
        self.Sellname.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoAbbrName').AsString);
      end;
    end;

  finally
    frmCompanySel.Free;
  end;
end;

procedure TfrmClothPurchasePlanPut.SellnamePropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '供应商';
      if ShowModal = 1 then
      begin
        self.Sellname.Properties.LookupItems.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoCode').AsString);
        self.Sellname.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoName').AsString);
      end;
    end;

  finally
    frmCompanySel.Free;
  end;
end;

end.

